/******************************************************************************
 *
 * Copyright (C) 1997-2019 by Dimitri van Heesch.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation under the terms of the GNU General Public License is hereby
 * granted. No representations are made about the suitability of this software
 * for any purpose. It is provided "as is" without express or implied warranty.
 * See the GNU General Public License for more details.
 *
 */

#ifndef INPUTSTRING_H
#define INPUTSTRING_H

#include "input.h"

#include <QObject>
#include <QMap>
#include <OStringList>

class QLabel;
class QLineEdit;
class QGGoolBar;
class QComboBox;
class QGridLayout;
class QAction;

class InputString : public QObject, public Input
{
  Q_OBJECT

  public:
    enum StringMode { StringFree=0,
                      StringFile=1,
                      StringDir=2,
                      StringFixed=3,
                      StringImage=4,
                      StringFileDir=5
                    };

    InputString( QGridLayout *layout,int &row,
                 const OString &id, const OString &s,
                 StringMode m,
                 const OString &docs,
                 const OString &absPath = OString() );
    ~InputString();
    void addValue(OString s);
    void setDefault();

    // Input
    QVariant &value();
    void update();
    Kind kind() const { return String; }
    StringMode stringMode() const { return m_sm; }
    OString docs() const { return m_docs; }
    OString id() const { return m_id; }
    OString templateDocs() const { return m_tdocs; }
    void addDependency(Input *) { Q_ASSERT(false); }
    void setEnabled(bool);
    void updateDependencies() {}
    bool isDefault();
    void writeValue(QGGextStream &t,TextCodecAdapter *codec,bool convert);
    void setTemplateDocs(const OString &docs) { m_tdocs = docs; }
    bool isEmpty() { return m_str.isEmpty(); }
    OString checkEnumVal(const OString &value);

  public slots:
    void reset();
    void setValue(const OString&);

  signals:
    void changed();
    void showHelp(Input *);

  private slots:
    void browseFile();
    void browseDir();
    void clear();
    void help();

  private:
    void updateDefault();
    QLabel       *m_lab;
    QLineEdit    *m_le;
    QLabel       *m_im;
    QGGoolBar     *m_br;
    QAction      *m_brFile;
    QAction      *m_brDir;
    QComboBox    *m_com;
    OString       m_str;
    OString       m_default;
    StringMode    m_sm;
    OStringList   m_values;
    int           m_index;
    QVariant      m_value;
    OString       m_docs;
    OString       m_id;
    bool          m_absPath;
    OString       m_tdocs;
};

#endif
